﻿Imports System
Imports System.ComponentModel
Imports System.Threading
Imports System.IO.Ports

Public Class Form1
    Dim myPort As Array
    Delegate Sub SetTextCallback(ByVal [text] As String)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        myPort = IO.Ports.SerialPort.GetPortNames()
        cmbBaud.Items.Add(9600)
        cmbBaud.Items.Add(19200)
        cmbBaud.Items.Add(38400)
        cmbBaud.Items.Add(57600)
        cmbBaud.Items.Add(115200)

        For i = 0 To UBound(myPort)
            cmbPort.Items.Add(myPort(i))
        Next
        cmbPort.Text = cmbPort.Items.Item(0)
        cmbBaud.Text = cmbBaud.Items.Item(0)

        btnDisconnect.Enabled = False

    End Sub


    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        SerialPort1.PortName = cmbPort.Text
        SerialPort1.BaudRate = cmbBaud.Text


        SerialPort1.Parity = IO.Ports.Parity.None
        SerialPort1.StopBits = IO.Ports.StopBits.One
        SerialPort1.DataBits = 8
        SerialPort1.Open()

        btnConnect.Enabled = False
        btnDisconnect.Enabled = True
    End Sub

    Private Sub btnDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisconnect.Click
        SerialPort1.Close()

        btnConnect.Enabled = True
        btnDisconnect.Enabled = False

        lbldata.Text = ""
        Call kosong()
    End Sub

    Sub kosong()
        DGV.Rows.Clear()
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        lblData.Invoke(New myDelegate(AddressOf updateTextBox), New Object() {})
    End Sub

    Public Delegate Sub myDelegate()

    Public Sub updateTextBox()
        'change the data received in hex format
        'processes the data received to be displayed in lblData and DataGridView

        Dim tagDataLength = 250 '--> one RFID tag has 250 bytes
        Dim Count As Integer = SerialPort1.BytesToRead '--> how many counts of bytes
        Dim Buffer(0 To Count - 1) As Byte

        Dim nArray = Convert.ToInt32(Count / tagDataLength) '--> to find out how many RFID tags there are
        Dim offsetStart As int32 = 12
        Dim ByteNeeded As int32 = 12
        Dim textToDisplay As String = String.Empty
        SerialPort1.Read(Buffer, 0, Count)
        For counter As Integer = 0 To nArray - 1
            Dim dataOnTag = buffer.Skip(counter * tagDataLength).Take(tagDataLength).ToArray()
            Dim dataNeeded = From m In dataOnTag.Skip(offsetStart).Take(ByteNeeded)
                                Select Conversion.Hex(m)

            textToDisplay &= String.Join(" ", dataNeeded).Trim() & Environment.NewLine
        Next

        lbldata.Text &= textToDisplay & vbNewLine

        Dim dataTagnya As String = Replace(lbldata.Text, " ", "")

        'Dim arrayText = textToDisplay.Split(vbCrLf.ToCharArray, StringSplitOptions.RemoveEmptyEntries)
        Dim arrayText = dataTagnya.Split(vbCrLf.ToCharArray, StringSplitOptions.RemoveEmptyEntries)

        For counter As Integer = 0 To nArray - 1
            With DGV
                Dim row As String() = New String() {arrayText(counter)}
                .Rows.Add(row)
            End With

        Next

        jumlah_data()

    End Sub

    Sub jumlah_data()
        lblJumlahData.Text = DGV.Rows.Count - 1
    End Sub

    Private Sub cmbPort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbPort.SelectedIndexChanged
        If SerialPort1.IsOpen = False Then
            SerialPort1.PortName = cmbPort.Text
        Else
            MsgBox("Only applies if the port is closed", vbCritical)
        End If
    End Sub

    Private Sub cmbBaud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbBaud.SelectedIndexChanged
        If SerialPort1.IsOpen = False Then
            SerialPort1.BaudRate = cmbBaud.Text
        Else
            MsgBox("Hanya berlaku jika port Ditutup", vbCritical)
        End If
    End Sub

End Class